SystemOrganization addCategory: #'JQWidgetBox-BubbleTip-Dev-Example'!
SystemOrganization addCategory: #'JQWidgetBox-BubbleTip-Dev-Tests'!

JQWidgetExample subclass: #JQBubbleTipExample
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JQWidgetBox-BubbleTip-Dev-Example'!

!JQBubbleTipExample classSide methodsFor: 'as yet unclassified' stamp: 'NickAger 2/4/2010 14:52'!
description
	^ 'JQuery Bubble tip'! !

!JQBubbleTipExample classSide methodsFor: 'as yet unclassified' stamp: 'NickAger 2/9/2010 00:50'!
shortName
	^'bubbletip'! !

!JQBubbleTipExample methodsFor: 'rendering' stamp: 'NickAger 2/9/2010 00:03'!
renderContentOn: html
	self renderIntroductionOn: html.
	self renderFeaturesOn: html.
	self renderExamples1On: html.
	self renderExamples2On: html.
	self renderExamples3On: html.
! !

!JQBubbleTipExample methodsFor: 'rendering' stamp: 'NickAger 2/9/2010 00:47'!
renderExamples1On: html
	html heading level: 4; with: 'Examples'.
	html paragraph: [
		html text: 'MOUSEOVER to open a tooltip '.
		html anchor
			url: '#';
			script: (html jQuery this bubbletip target: (html jQuery: #tip1Up));
			with: 'above'.
		html text: ', '.
		html anchor
			url: '#';
			script: (html jQuery this bubbletip 
				target: (html jQuery: #tip1Down);
				deltaDirection: 'down';
				deltaPosition: 50;
				offsetTop: 20);
			 with: 'below'.
		html text: ', '.
		html anchor
			url: '#';
			script: (html jQuery this bubbletip
				target: (html jQuery: #tip1Left);
				deltaDirection: 'left';
				animationDuration: 100;
				offsetLeft: -20);
			with: 'to the left'.
		html text: ' or '.
		html anchor
			url: '#';
			script: (html jQuery this bubbletip
				target: (html jQuery: #tip1Right);
				deltaDirection: 'right');
			with: 'to the right'.
		html text: ' or any element'.
		].

	html div style: 'display:none'; with: [
		html div id: #tip1Up; with: [
			html preformatted class: 'tip'; with: 
'html jQuery this bubbletip
	target: (html jQuery: #tip1Up)'
			]. 
		html div id: #tip1Down; with: [
			html preformatted class: 'tip'; with: 
'html jQuery this bubbletip 
	target: (html jQuery: #tip1Down);
	deltaDirection: ''down'';
	deltaPosition: 50;
	offsetTop: 20)'
			].
		html div id: #tip1Left; with: [
			html preformatted class: 'tip'; with: 
'html jQuery this bubbletip 
	target: (html jQuery: #tip1Left);
	deltaDirection: ''left'';
	animationDuration: 100;
	offsetLeft: -20)'
			].
		html div id: #tip1Right; with: [
			html image
				url: (WAToolFiles / #logoPng)
			].
		]
! !

!JQBubbleTipExample methodsFor: 'rendering' stamp: 'NickAger 2/8/2010 20:10'!
renderExamples2On: html
	html paragraph: [
		html text: 'MOUSEOVER a '.
		html anchor
			url: '#';
			script: (html jQuery this bubbletip
				target: (html jQuery: #tip1Trigger1);
				positionAtElement: (html jQuery: #a1Target));
			script: (html jQuery this bubbletip
				target: (html jQuery: #tip1Trigger2);
				positionAtElement: (html jQuery: #a1Target);
				deltaDirection: 'down');
			with: 'trigger element'.
		html text: ' to open a tooltip above and below a '.
		html anchor 
			url: '#';
			id: #a1Target;
			with: 'target element'
		].

	html div style: 'display:none'; with: [
		html div id: #tip1Trigger1; with: [
			html preformatted class: 'tip'; with: 
'html jQuery this bubbletip
	target: (html jQuery: #tip1Trigger1);
	positionAtElement: (html jQuery: #a1Target)'			
			].
		html div id: #tip1Trigger2; with: [
			html preformatted class: 'tip'; with: 
'html jQuery this bubbletip
	target: (html jQuery: #tip1Trigger2);
	positionAtElement: (html jQuery: #a1Target);
	deltaDirection: ''down'''.
			].		
		]
! !

!JQBubbleTipExample methodsFor: 'rendering' stamp: 'NickAger 2/9/2010 08:13'!
renderExamples3On: html
	html paragraph: [
		html text: '[self-contained examples] MOUSEOVER to open a tooltip '.
		html anchor
			url: '#';
		script: (html jQuery this bubbletip target: (html jQuery html: 
			[:r | r preformatted class: 'tip'; id: #id101; with: 
				'Here the popup text is defined within 
the script attached to the anchor']));
			with: 'above'.
		html text: ', '.
		html anchor
			url: '#';
			script: (html jQuery this bubbletip 
				target: (html jQuery html: [:r | r paragraph id: #id102; with: [
					r text: 'In these self contained examples, the html passed to the target '. 
					r break.
					r emphasis: 'must'. 
					r text: ' be include an enclosing html element with a defined id']]);
				deltaDirection: 'down');
			 with: 'below'.
		html text: ', '.
		html anchor
			url: '#';
			script: (html jQuery this bubbletip
				target: (html jQuery  html: 
					[:r | r div id: #id103; with: 
						[r text: 'study the samples'.
						r break.
						r text: 'for more detail.']]);
				deltaDirection: 'left';
				animationDuration: 100);
			with: 'to the left'.
		html text: ' or '.
		html anchor
			url: '#';
			script: (html jQuery this bubbletip
				target: (html jQuery html: [:r | r image id: #id104;
				url: (WAToolFiles / #logoPng)]);
				deltaDirection: 'right');
			with: 'to the right'.
		html text: ' or any element'.
		].! !

!JQBubbleTipExample methodsFor: 'rendering' stamp: 'NickAger 2/8/2010 20:06'!
renderFeaturesOn: html
	html heading level: 4; with: 'Features'.
	html unorderedList with: [ 
		html listItem: 'multiple tips on a page'.
		html listItem: 'multiple tips per jQuery element'.
		html listItem: 'tips open outward in four directions:'.

		html unorderedList with: [
			html listItem: 'up'.
			html listItem: 'down'.
			html listItem: 'left'.
			html listItem: 'right'.
			].
		
		html listItem: 'tips can be:'.
		html unorderedList with: [
			html listItem: 'anchored to the triggering jQuery element'.
			html listItem: 'absolutely positioned'.
			html listItem: 'opened at the current mouse coordinates'.
			html listItem: 'anchored to a specified jQuery element'
			]
		].
! !

!JQBubbleTipExample methodsFor: 'rendering' stamp: 'NickAger 2/9/2010 08:06'!
renderIntroductionOn: html
	html heading level: 3; with: 'bubbletip'.
	html paragraph: 'A jQuery plugin to create a bubble-stylized tooltip popups'. 
	html heading level: 4; with: 'original bubble-tip documentation and download'.
	html paragraph: [
		html unorderedList: [
			html listItem: [html anchor url: 'http://code.google.com/p/bubbletip'; with: 'http://code.google.com/p/bubbletip'].
			html listItem: [html anchor url: 'http://plugins.jquery.com/project/bubbletip'; with: 'jQuery bubbletip home'].
			]
		].
! !

!JQBubbleTipExample methodsFor: 'processing' stamp: 'NickAger 2/8/2010 17:52'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	anHtmlRoot javascript url: JQWidgetBoxLibrary / #jQuerybubbletipJs.
	anHtmlRoot stylesheet url: JQWidgetBoxLibrary / #bubbletipCss.
	
	anHtmlRoot stylesheet add: 'pre.tip{margin: 0px;padding: 5px;font-size: 0.9em;}'! !

JQWidgetBoxWidgetTest subclass: #JQBubbleTipTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JQWidgetBox-BubbleTip-Dev-Tests'!

!JQBubbleTipTest methodsFor: 'testing' stamp: 'NickAger 2/9/2010 00:53'!
testActions
	self
		assert: ((self jQuery: 'id') bubbletip target: (self jQuery: #idTarget))
		equals: self function, '("id").bubbletip($("#idTarget"))'.
	! !
